/*
 * Copyright 2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.callbackparams.internal;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import org.callbackparams.internal.template.TestrunCallbacks;

/**
 * @author Henrik Kaipe
 */
class CallbackContextImpl implements CallbackContext {

    public void addFieldToInject(Field f) {
        TestrunCallbacks.addFieldToInject(f);
    }

    public Iterator iterateFields() {
        return TestrunCallbacks.iterateFields();
    }

    public int addMethodParams(Method m) {
        return TestrunCallbacks.addMethodParams(m);
    }

    public Iterator iterateMethods() {
        return TestrunCallbacks.iterateMethods();
    }

    public List getCallbackRecord() {
        return new ArrayList(TestrunCallbacks.getCurrentCallbackRecord());
    }

    public void setCallbackRecord(Collection callbackRecord) {
        TestrunCallbacks.setCallbackRecord(callbackRecord);
    }
}
