/*
 * Copyright 2013 the original author or authors.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.callbackparams.internal.template;

import java.lang.reflect.Member;
import org.callbackparams.support.ExceptionUtil;

/**
 * @author Henrik Kaipe
 */
public abstract class CallbackFieldWarning {

    private static final CallbackFieldWarning instance =
            createCallbackFieldWarning();

    static void possibleDeprecationWarning(Member m) {
        if (null != instance) {
            instance.possibleDeprecationWarningInternal(m);
        }
    }

    private static CallbackFieldWarning createCallbackFieldWarning() {
        String actualCallbackFieldWarningClassName = CallbackFieldWarning.class
                .getName().replaceFirst("C", "annotation.C");
        try {
            return (CallbackFieldWarning) Class
                    .forName(actualCallbackFieldWarningClassName).newInstance();
        } catch (UnsupportedClassVersionError detectionOf_JDK1_4) {
            return null;
        } catch (Exception shouldNeverHappen) {
            throw ExceptionUtil.unchecked(shouldNeverHappen);
        }
    }

    protected abstract void possibleDeprecationWarningInternal(Member m);
}
