/*
 * Copyright 2010-2012 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * JUnit-3.8.x integration. This API is compatible with JDK-1.4.
 * <br/><br/>
 * Since annotations are not supported under JDK-1.4 there are alternatives
 * available ...
 * <br/> 1) Combine-configuration can be tweaked by low-level APIs that allow the
 * test-developer to override
 * {@link org.callbackparams.combine.reflect.CallbackRecordsFactory CallbackRecordsFactory}.
 * <br/> 2) Callback-injection is performed for all interface fields, i.e. not
 * just the fields that are annotated with
 * {@link org.callbackparams.ParameterizedCallback @ParameterizedCallback}.
 * <br/><br/>
 * When this API is used under JDK-1.5+ the
 * {@link org.callbackparams.combine.annotation combine-annotations} are
 * automagically enabled, thus making alternative 1) less attractive.
 * {@link org.callbackparams.ParameterizedCallback @ParameterizedCallback}-annotated
 * interface-fields are of course callback-injected but all other
 * interface-fields will be injected as well. (Which only means that
 * uninitialized interface-fields will be non-null when the constructor runs, so
 * it will only be a minor inconvenience ...) <br/>
 * Nevertheless test-developers are encouraged to upgrade to JUnit-4.x ASAP
 * and switch to the integration-API provided by
 * {@link org.callbackparams.junit4.CallbackParamsRunner CallbackParamsRunner},
 * because of the advantages it offers while still allowing existing tests
 * to use the JUnit-3.8.x API.
 */
package org.callbackparams.junit3;
