/*
 * Copyright 2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.callbackparams.junit4.support;

import org.callbackparams.AdaptiveRule;
import org.junit.rules.MethodRule;
import org.junit.runners.model.FrameworkMethod;
import org.junit.runners.model.Statement;

/**
 * @author Henrik Kaipe
 */
public class AdaptiveRuleAsJunitRule implements MethodRule {

    public Statement apply(
            final Statement base,
            FrameworkMethod methodIsIgnored,
            Object target)
    {
        final AdaptiveRule.TestRun testRun = new AdaptiveRule.TestRun() {
            public Object executeTestMethod() throws Throwable {
                base.evaluate();
                return null;
            }
        };
        final AdaptiveRule thisAsAdaptiveRule = (AdaptiveRule)(Object)this;

        return new Statement() {
            public void evaluate() throws Throwable {
                thisAsAdaptiveRule.evaluate(testRun);
            }
        };
    }
}
