/*
 * Copyright 2012 the original author or authors.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.callbackparams.support;

/**
 * @author Henrik Kaipe
 */
public abstract class AnnotationInjector {

    private static final AnnotationInjector instance =
            createAnnotationInjector();

    public static void injectAnnotations(Object target, Object enumConstant) {
        if (null == instance) {
            return;
        } else {
            instance.injectAnnotationsInternal(target, enumConstant);
        }
    }

    private static AnnotationInjector createAnnotationInjector() {
        String actualAnnotationAwareClassName =  AnnotationInjector.class
                .getName().replaceFirst("A", "annotation.A");
        try {
            return (AnnotationInjector)
                    Class.forName(actualAnnotationAwareClassName).newInstance();
        } catch (UnsupportedClassVersionError detectionOf_JDK1_4) {
            return null;
        } catch (Exception shouldNeverHappen) {
            throw ExceptionUtil.unchecked(shouldNeverHappen);
        }
    }

    protected abstract void injectAnnotationsInternal(
            Object target, Object enumConstant);
}
