/*
 * Copyright 2010-2012 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.callbackparams.support;

import java.util.HashMap;
import java.util.Map;

/**
 * @author Henrik Kaipe
 */
public class DefaultValue {

    private static final Map map = new HashMap();
    static {
        map.put(int.class, new Integer(0));
        map.put(boolean.class, Boolean.FALSE);
        map.put(long.class, new Long(0));
        map.put(char.class, new Character((char) 0));
        map.put(double.class, new Double(0.0));
        map.put(byte.class, new Byte((byte) 0));
        map.put(float.class, new Float(0.0F));
        map.put(short.class, new Short((short) 0));
    }

    public static Object forType(final Class type) {
        return map.get(type);
    }
}
