/*
 * Copyright 2011-2012 the original author or authors.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.callbackparams.wrap;

import org.callbackparams.wrap.legacy.WrappingLegacySupport;

/**
 * @author Henrik Kaipe
 */
public class WrappingSupport<V>
extends WrappingLegacySupport implements Wrapping<V> {

    public V wrappedValue() {
        return (V) super.wrappedValue();
    }

    /**
     * Same as
     * {@link WrappingLegacySupport#wrapArray(java.lang.Class, java.lang.Object[])}
     * but with a Java5+ enhanced method-signature, which has two generic
     * type-parameters and a vararg argument.
     */
    public static <W extends Wrapping<V>, V> W[] wrap(
            Class<W> targetClass, V... wrappedValues) {
        return (W[]) WrappingLegacySupport.wrapArray(targetClass, wrappedValues);
    }
}
